commit 2580348caf4d5253344f07fa97dbe161e04dacb8
Author: freddy77 <freddy77>
Date:   Mon Oct 27 14:27:01 2008 +0000

    implement conversion from SQL_C_WCHAR to no char

diff --git a/ChangeLog b/ChangeLog
index 102fd32..795bcb3 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Oct 27 15:25:06 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/sql2tds.c src/odbc/unittests/genparams.c:
+	- implement conversion from SQL_C_WCHAR to no char
+
 Mon Oct 27 15:21:50 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* TODO.freddy src/odbc/odbc.c src/odbc/unittests/getdata.c:
 	- improve and fix test for SQLGetData and SQL_C_WCHAR
@@ -782,4 +786,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2639 2008/10/27 14:23:22 freddy77 Exp $
+$Id: ChangeLog,v 1.2640 2008/10/27 14:27:01 freddy77 Exp $
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 56595ac..896f15e 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.77 2008/10/24 08:29:22 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.78 2008/10/27 14:27:01 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -126,6 +126,35 @@ convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
 	return sizeof(TDS_DATETIME);
 }
 
+static char*
+odbc_wstr2str(TDS_STMT * stmt, const char *src, int* len)
+{
+	int srclen = (*len) / sizeof(SQLWCHAR);
+	char *out = (char *) malloc(srclen + 1), *p;
+	const SQLWCHAR *wp = (const SQLWCHAR *) src;
+
+	if (!out) {
+		odbc_errs_add(&stmt->errs, "HY001", NULL);
+		return NULL;
+	}
+
+        /* convert */
+        p = out;
+	for (; srclen && *wp < 256; --srclen)
+		*p++ = *wp++;
+
+	/* still characters, wrong format */
+	if (srclen) {
+		free(out);
+		/* TODO correct error ?? */
+		odbc_errs_add(&stmt->errs, "07006", NULL);
+		return NULL;
+	}
+
+	*len = p - out;
+	return out;
+}
+
 /**
  * Convert parameters to libtds format
  * @return SQL_SUCCESS, SQL_ERROR or SQL_NEED_DATA
@@ -138,7 +167,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 	int dest_type, src_type, sql_src_type, res;
 	CONV_RESULT ores;
 	TDSBLOB *blob;
-	char *src;
+	char *src, *converted_src;
 	unsigned char *dest;
 	int len;
 	TDS_DATETIME dt;
@@ -317,7 +346,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 	case XSYBNVARCHAR:
 	case XSYBNCHAR:
 	case SYBNVARCHAR:
-		if (!need_data && is_char_type(src_type)) {
+		if (!need_data && (sql_src_type == SQL_C_CHAR || sql_src_type == SQL_C_WCHAR)) {
 			if (curcol->column_data && curcol->column_data_free)
 				curcol->column_data_free(curcol);
 			curcol->column_data_free = NULL;
@@ -370,6 +399,14 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		/* TODO intervals */
 	}
 
+	converted_src = NULL;
+	if (sql_src_type == SQL_C_WCHAR) {
+		converted_src = src = odbc_wstr2str(stmt, src, &len);
+		if (!src)
+			return SQL_ERROR;
+		src_type = SYBVARCHAR;
+	}
+
 	dest = curcol->column_data;
 	switch ((TDS_SERVER_TYPE) dest_type) {
 	case SYBCHAR:
@@ -396,6 +433,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 			res = curcol->column_size;
 		break;
 	case SYBTEXT:
+	case SYBNTEXT:
 	case SYBLONGBINARY:
 	case SYBIMAGE:
 		res = tds_convert(dbc->env->tds_ctx, src_type, src, len, dest_type, &ores);
@@ -433,7 +471,6 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		res = tds_convert(dbc->env->tds_ctx, src_type, src, len, dest_type, (CONV_RESULT*) dest);
 		break;
 	default:
-	case SYBNTEXT:
 	case SYBVOID:
 	case SYBVARIANT:
 		/* TODO ODBC 3.5 */
@@ -442,6 +479,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		break;
 	}
 
+	free(converted_src);
 	if (res < 0) {
 		odbc_convert_err_set(&stmt->errs, res);
 		return SQL_ERROR;
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 15e91c9..0a32c39 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -7,18 +7,18 @@
 /*
  * This test is useful to test odbc_sql2tds function using TestInput
  * odbc_sql2tds have some particular cases:
- * (1) char    -> char     handled differently with encoding problems DONE
- * (2) date    -> *        different format
- * (3) numeric -> *        different format DONE
- * (4) *       -> numeric  take precision and scale from ipd
+ * (1) char    -> char     handled differently with encoding problems
+ * (2) date    -> *        different format TODO
+ * (3) numeric -> *        different format
+ * (4) *       -> numeric  take precision and scale from ipd TODO
  * (5) *       -> char     test wide
- * (6) *       -> blob     test wchar and ntext
- * (7) *       -> binary   test also with wchar
- * (8) binary  -> *        test aldo with wchar
+ * (6) *       -> blob     test wchar and ntext TODO
+ * (7) *       -> binary   test also with wchar TODO
+ * (8) binary  -> *        test also with wchar TODO
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.34 2008/10/24 08:29:22 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.35 2008/10/27 14:27:01 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -336,9 +336,7 @@ AllTests(void)
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WVARCHAR, "NVARCHAR(10)", "1EasyTest3");
 		TestInput(SQL_C_WCHAR, "NVARCHAR(3)", SQL_WVARCHAR, "NVARCHAR(3)", "0xf800a300bc06");
 
-#ifdef ENABLE_DEVELOPING
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_INTEGER, "INT", " -423785  -> -423785");
-#endif
 	}
 }
 

